/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "iic_demo.h"
#include "delay_demo.h"
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
#define USING_24C02

#define SLVADDR                                 (0xA0U)

extern volatile uint8_t   g_iic_tx_end;             /* iica0 send data end */
extern volatile uint8_t   g_iic_rx_end;             /* iica0 receive data end */

uint8_t rx_buf[3];




int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint8_t tx_buf[3] = {0xA5, 0x55, 0x5A};
    uint8_t tx_buf1[4] = {0x01, 0xA5, 0x55, 0x5A};
    uint32_t err;
    uint32_t i = 0, j = 100;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock); //ʱʼ

    Uart0_Init(19200);
    printf("IIC\n");
    Iic20_Init();
	Iic21_Init();
    Iic30_Init();
    Iic31_Init();
#ifdef USING_24C02
#ifdef IIC_USING_POLLING_WAY/*offer two ways to driver 24C02*/
    I2C_WriteData(I2C31, SLVADDR, 0x01, tx_buf, 3);
    delayMS(200);
    I2C_ReadData(I2C31, SLVADDR, 0x01, rx_buf, 3);
    printf("IIC Send ok \n");
#else
    Iic20_Write(SLVADDR, tx_buf1, 4);

    while (g_iic_tx_end == 0);

    printf("IIC Send ok\n");
    delayMS(200);

    Iic20_Write(SLVADDR, tx_buf1, 1);

    while (g_iic_tx_end == 0);

    Iic20_Read(SLVADDR, rx_buf, 3);

    while (g_iic_rx_end == 0);

#endif
#else

    while (i < 100)
    {
        I2C_WriteData(I2C20, SLVADDR, j++, tx_buf, 3);
        delayMS(20);
        I2C_ReadData(I2C20, SLVADDR, i, rx_buf, 3);
        delayMS(20);
        i++;
    }

#endif

}




