#ifndef __IICA_DEMO_H__

#include "i2ca.h"
#include "gpio.h"
#include "isr.h"

#define I2CA_USING_POLLING
//#define I2CA_USING_INTERRUPT
typedef enum
{
	IICA_INT_IDLE = 0,
	IICA_INT_RX = 1,
	IICA_INT_TX = 2,
}IICA_DIR_t;

typedef struct 
{
	IICA_DIR_t flag;
	uint32_t len;
	volatile uint8_t *data;
}IICA_FRAME_t;

void iica0_interrupt(void);
void Iica0_Init(void);
void iica1_interrupt(void);
void Iica1_Init(void);

void IICA_SlaveSend(uint8_t adr, uint8_t *const tx_buf, uint16_t tx_num);
void IICA_SlaveReceive(uint8_t adr, uint8_t *const rx_buf, uint16_t rx_num);
int IICA0_MasterWrite(uint8_t adr, uint8_t *tx_buf, uint16_t tx_num, uint8_t wait);
int IICA0_MasterReceive(uint8_t adr, uint8_t *const rx_buf, uint16_t rx_num, uint8_t wait);



#endif
