#include "iica_demo.h"
volatile uint8_t   g_iica_tx_end;             /* iica0 send data end */
volatile uint8_t   g_iica_rx_end;             /* iica0 receive data end */
uint16_t  g_iica_rx_cnt;                     /* iica1 receive data count */
uint16_t  g_iica_rx_len;                     /* iica1 receive data length */
static uint8_t tx_buf[8] = { 1, 2, 3, 4, 5, 6, 7, 8 };
static uint8_t rx_buf[8] = { 0 };
static uint16_t tx_length = 8, rx_length = 0;
I2CA_Slave_Event event;
#define _80_IICA_ADDRESS_COMPLETE                     (0x80U)
#define _00_IICA_MASTER_FLAG_CLEAR                    (0x00U)
static IICA_FRAME_t pData; /*pData used as an example,user can dinfine different paramater according to needs*/

void Iica0_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    I2CA_InitTypeDef I2CA_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_0, GPIO_P60, GROUP_AF_SCLAA0); //SCLA0 can be allocated to any desired pins in group0
    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_1, GPIO_P61, GROUP_AF_SDAA0); //SDAA0 can be allocated to any desired pins in group0

    /*SCLA0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_PuPd   = GPIO_PuPd_UP;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SDAA0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_PuPd   = GPIO_PuPd_UP;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    I2CA_InitStructure.I2C_ClockSpeed = 800000;
    I2CA_InitStructure.I2C_Ack = I2CA_Ack_Enable;
    I2CA_InitStructure.I2C_DutyCycle = 50;
    I2CA_InitStructure.I2C_OwnAddress = 0xA0;
    I2CA_InitStructure.I2C_Mode = I2CA_Mode_SMBusSlave;
    I2CA_Init(I2CA0,&I2CA_InitStructure);


#ifdef I2CA_USING_INTERRUPT
    ISR_Register(IICA0_IRQn, iica0_interrupt);
#endif
}

#if defined(BAT32G1XX_100PIN) || defined(BAT32G1XX_80PIN)

void Iica1_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    I2CA_InitTypeDef I2CA_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SCLA1 can be allocated to any desired pins in group0
    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_3, GPIO_P63, GROUP_AF_ODEFAULT); //SDAA1 can be allocated to any desired pins in group0

    /*SCLA0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_PuPd   = GPIO_PuPd_UP;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SDAA0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_PuPd   = GPIO_PuPd_UP;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    I2CA_InitStructure.I2C_ClockSpeed = 800000;
    I2CA_InitStructure.I2C_Ack = I2CA_Ack_Enable;
    I2CA_InitStructure.I2C_DutyCycle = 50;
    I2CA_InitStructure.I2C_OwnAddress = 0xA0;
    I2CA_InitStructure.I2C_Mode = I2CA_Mode_SMBusSlave;
    I2CA_Init(I2CA1,&I2CA_InitStructure);


#ifdef I2CA_USING_INTERRUPT
    ISR_Register(IICA1_IRQn, iica1_interrupt);
#endif
}

void iica1_interrupt(void)
{
    INTC_ClearPendingIRQ(IICA1_IRQn);
	
	I2CA_Slave_TransmitReceive_IT(I2CA1,tx_buf, &tx_length, rx_buf, &rx_length, 8);
}

#endif
/***********************************************************************************************************************
* Function Name: IICA0_SlaveSend
* @brief  This function sends data as slave mode.
* @param  adr - send address
* @param  tx_buf - transfer buffer pointer
* @param  tx_num - buffer size
* @return None
***********************************************************************************************************************/
void IICA0_SlaveSend(uint8_t adr, uint8_t *const tx_buf, uint16_t tx_num)
{
    g_iica_tx_end = 0;
    pData.len = tx_num;
    pData.data = tx_buf;
    pData.flag = IICA_INT_TX;
	I2CA_WriteByte(I2CA0,adr);/* slave address */

}
/***********************************************************************************************************************
* Function Name: IICA0_SlaveReceive
* @brief  This function receives data as slave mode.
* @param  adr - send address
* @param  tx_buf - receive buffer pointer
* @param  rx_num - buffer size
* @return None
***********************************************************************************************************************/
void IICA0_SlaveReceive(uint8_t adr, uint8_t *const rx_buf, uint16_t rx_num)
{
    g_iica_rx_end = 0;
    g_iica_rx_len = 0;
    g_iica_rx_cnt = rx_num;
    pData.len = 0;
    pData.data = rx_buf;
    pData.flag = IICA_INT_RX;
	I2CA_WriteByte(I2CA0,adr);/* slave address */

}




/***********************************************************************************************************************
* Function Name: iica0_slavehandler
* @brief   This function is IICA0 slave handler.
* @param  None
* @return None
***********************************************************************************************************************/

uint8_t addrMatchrx = 0;
uint8_t addrMatchtx = 0;
uint8_t Stop_count = 0;
__IOM uint8_t Reg = 0;
static void iica0_slavehandler()
{
    IICA_FRAME_t *pFrame = &pData;

    /* Control for stop condition */
    if (I2CA_GetFlagStaus(I2CA0,I2CA_STATUS_SPD))
    {
        /* Get stop condition */
        Stop_count++;

        if (pFrame->flag == IICA_INT_TX && Stop_count == 2)  // send flag
        {
            /* Disable I2CA stop condition interrupt*/
			I2CA_CLEAR_REG(I2CA0,IICCTL00,I2CA_SPIE_BIT);
            g_iica_tx_end = 1; //slave_sendend
            addrMatchtx = 0;
            Stop_count = 0;
        }

        if (pFrame->flag == IICA_INT_RX)
        {
			I2CA_CLEAR_REG(I2CA0,IICCTL00,I2CA_SPIE_BIT);
            g_iica_rx_end = 1; //slave_receiveend
            g_iica_rx_len = pFrame->len;
            addrMatchrx = 0;
            Stop_count = 0;
        }
    }
    else
    {
        if (pFrame->flag == IICA_INT_RX)
        {
            if (!addrMatchrx && I2CA_GetFlagStaus(I2CA0,I2CA_STATUS_COI))   //ַƥ
            {
                addrMatchrx = 1;

				I2CA_SET_REG(I2CA0,IICCTL00,I2CA_SPIE_BIT); /* SPIE0 = 1: enable I2CA stop condition interrupt */

                I2CA_SET_REG(I2CA0,IICCTL00,I2CA_ACK_BIT);   /* ACKE0 = 1U: enable acknowledgment */
                /* interrupt request is generated at the eighth clock's falling edge */
				I2CA_CLEAR_REG(I2CA0,IICCTL00,I2CA_WTIM_BIT);


                /* cancel wait */
				I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WREL_BIT);
            }
            else
            {
                if (pFrame->len < g_iica_rx_cnt)
                {
                    *pFrame->data = I2CA_ReadByte(I2CA0);
                    pFrame->data++;
                    pFrame->len++;

					I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WREL_BIT);   // WREL0 = 1U: cancel wait

                    if (g_iica_rx_cnt == pFrame->len)
                    {
                        I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WTIM_BIT); // WTIM0 = 1:  interrupt request is generated at the ninth clock's falling edge
                        g_iica_rx_end = 1;                           // slave receive finished
                        g_iica_rx_len = pFrame->len;
                        addrMatchrx = 0;
                    }
                }
                else
                {
                    I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WTIM_BIT);   // WTIM0 = 1:  interrupt request is generated at the ninth clock's falling edge
					I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WREL_BIT);   // WREL0 = 1U: cancel wait 
				}
            }
        }

        if (pFrame->flag == IICA_INT_TX)
        {
            if ((addrMatchtx < 2) && I2CA_GetFlagStaus(I2CA0,I2CA_STATUS_COI)) //ַƥ
            {
                addrMatchtx ++;

                if (addrMatchtx == 1)
                {
                    IICA0->SVA |= 0x01;    //һȶ
                }
                else if (addrMatchtx == 2)
                {
                    Reg = IICA0->IICA;
                    IICA0->SVA &= ~0x01;
                }

                if (!(IICA0->IICCTL0 & I2CA_SPIE_ENABLE))
                {
					I2CA_SET_REG(I2CA0,IICCTL00,I2CA_SPIE_BIT); /* SPIE0 = 1: enable I2CA stop condition interrupt */
                }

                /* Sending or receiving */
                if (I2CA_GetFlagStaus(I2CA0,I2CA_STATUS_TRC))    //send status
                {
                    I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WTIM_BIT);   //9ʱӣʱΪ͵ƽ
                }
                else
                {
                   	I2CA_CLEAR_REG(I2CA0,IICCTL00,I2CA_WTIM_BIT);    // interrupt request is generated at the eighth clock's falling edge
					I2CA_SET_REG(I2CA0,IICCTL00,I2CA_WREL_BIT);   // WREL0 = 1U: cancel wait 
                }
            }
            else
            {
                if (I2CA_GetFlagStaus(I2CA0,I2CA_STATUS_TRC))  /* TRC0 == 1 */
                {
                    if (pFrame->len > 0U)
                    {
						I2CA_WriteByte(I2CA0,*pFrame->data);
                        pFrame->data++;
                        pFrame->len--;
                    }
                    else
                    {
						I2CA_WriteByte(I2CA0,0xFF);
                        g_iica_tx_end = 1;
                    }
                }
            }

        }

    }
}

void iica0_interrupt(void)
{
    INTC_ClearPendingIRQ(IICA0_IRQn);
//	iica0_slavehandler();
	event = I2CA_Slave_TransmitReceive_IT(I2CA0,tx_buf, &tx_length, rx_buf, &rx_length, 8);
}
