/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : spi_demo.c                                                 *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "spi_demo.h"
#include "dma_demo.h"
static SSPI_FRAME_t pData; /*pData used as an example,user can dinfine different paramater according to needs*/

volatile uint8_t *gp_sspi_rx_address;       /* spi receive buffer address */
volatile uint16_t g_sspi_rx_count;          /* spi receive data count */
/***********************************************************************************************************************
* Function Name: Spi0_Init
* @brief simple spi init
* @param
* @return  status
***********************************************************************************************************************/
void NSS_set()
{
    GPIO_SetBits(GPIO_PORT6, GPIO_Pin_3);
}
void NSS_clr()
{
    GPIO_ResetBits(GPIO_PORT6, GPIO_Pin_3);
}
/***********************************************************************************************************************
* Function Name: Spi00_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi00_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS00 can be disired to any pins GROUP_AF_SS00
    GPIO_PinAFConfig(GPIO_PORT3, GPIO_Pin_0, GPIO_P30, GROUP_AF_ODEFAULT); // SCLK_OUTPUT can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_1, GPIO_P51, GROUP_AF_ODEFAULT); // MOSI(SDO00) can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_0, GPIO_P50, GROUP_AF_ODEFAULT); // MSIO(SDI00) can be disired to any pins

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT3, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;             //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;       //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;     //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;               //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;          //ѡbitȴ
	SPI_InitStructure.SPI_Int_Source = SPI_Interrupt_TransferEnd;//ж

    res = SSPI_Init(SSPI00, &SPI_InitStructure);

    ISR_Register(SPI00_IRQn, spi00_interrupt);  //жϷ·ע

    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi00_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi01_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS00 can be disired to any pins GROUP_AF_SS00
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_5, GPIO_P75, GROUP_AF_ODEFAULT); // SCLK_OUTPUT  disired to default pins
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_3, GPIO_P73, GROUP_AF_ODEFAULT); // MOSI(SDO00) disired to default pins
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_4, GPIO_P74, GROUP_AF_ODEFAULT); // MSIO(SDI00) disired to default pins

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;             //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;       //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;     //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;               //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;          //ѡbitȴ
	SPI_InitStructure.SPI_Int_Source = SPI_Interrupt_TransferEnd;//ж

    res = SSPI_Init(SSPI01, &SPI_InitStructure);

//    ISR_Register(SPI01_IRQn, spi01_interrupt);  //жϷ·ע

    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi10_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi10_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS10 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_4, GPIO_P04, GROUP_AF_ODEFAULT); // SCLK_OUTPUT can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_2, GPIO_P02, GROUP_AF_ODEFAULT); // MOSI(SDO10) can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_3, GPIO_P03, GROUP_AF_ODEFAULT); // MSIO(SDI10) can be disired to any pins with SDI10PCFG register

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);


    SPI_InitStructure.SPI_Mode      = SPI_Mode_Master;        //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize  = SPI_Data_Bits_8;        //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;       //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;               //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder  = SPI_Bit_Msb;            //ѡbitȴ
	SPI_InitStructure.SPI_Int_Source = SPI_Interrupt_TransferEnd;//ж

    res = SSPI_Init(SSPI10, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    //  ISR_Register(SPI10_IRQn,spi10_interrupt);        //жϷ·ע
    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi11_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi11_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS10 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_0, GPIO_P10, GROUP_AF_ODEFAULT); // SCLK11_OUTPUT default fuction with P10
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_2, GPIO_P12, GROUP_AF_ODEFAULT); // MOSI(SDO11) default fuction with P12
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_1, GPIO_P11, GROUP_AF_ODEFAULT); // MSIO(SDI11) default fuction with P11

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;            //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;        //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;      //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 8000000;              //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;            //ѡbitȴ
	SPI_InitStructure.SPI_Int_Source = SPI_Interrupt_TransferEnd;//ж
	
    res = SSPI_Init(SSPI11, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    ISR_Register(SPI11_IRQn, spi11_interrupt);  //жϷ·ע

    NSS.Active = NSS_clr;                             //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز
    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi20_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi20_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_3, GPIO_P63, GROUP_AF_ODEFAULT); //SS20 can be disired to default pins
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_5, GPIO_P15, GROUP_AF_ODEFAULT); // SCLK20_OUTPUT can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_3, GPIO_P13, GROUP_AF_ODEFAULT); // MOSI(SDO20)  can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_4, GPIO_P14, GROUP_AF_ODEFAULT); // MSIO(SDI20) can be disired to any pins with SDI20PCFG register

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                  //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;                   //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;                //ѡbitȴ
	SPI_InitStructure.SPI_Int_Source = SPI_Interrupt_TransferEnd;//ж

    res = SSPI_Init(SSPI20, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    //  ISR_Register(SPI20_IRQn, spi20_interrupt);       //жϷ·ע
    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    return SCI_SUCCESS;
}
/***********************************************************************************************************************
* Function Name: Spi21_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi21_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_3, GPIO_P63, GROUP_AF_ODEFAULT); //SS21 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_0, GPIO_P70, GROUP_AF_ODEFAULT); // SCLK21_OUTPUT default function with P70
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_2, GPIO_P72, GROUP_AF_ODEFAULT); // MOSI(SDO21) default function with P72
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_1, GPIO_P71, GROUP_AF_ODEFAULT); // MSIO(SDI20) default function with P71

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;              //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;          //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;        //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;                 //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ
	SPI_InitStructure.SPI_Int_Source = SPI_Interrupt_TransferEnd;//ж

    res = SSPI_Init(SSPI21, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    //  ISR_Register(SPI21_IRQn, spi21_interrupt);       //жϷ·ע

    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    return SCI_SUCCESS;
}
#if defined(BAT32G1XX_80PIN) ||defined(BAT32G1XX_100PIN)
/***********************************************************************************************************************
* Function Name: Spi31_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi31_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT4, GPIO_Pin_2, GPIO_P42, GROUP_AF_ODEFAULT); //SS31 can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT4, GPIO_Pin_3, GPIO_P43, GROUP_AF_ODEFAULT); // SCLK31_OUTPUT default function with P43
    GPIO_PinAFConfig(GPIO_PORT4, GPIO_Pin_5, GPIO_P45, GROUP_AF_ODEFAULT); // MOSI(SDO31) default function with P45
    GPIO_PinAFConfig(GPIO_PORT4, GPIO_Pin_4, GPIO_P44, GROUP_AF_ODEFAULT); // MSIO(SDI31) default function with P44

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT4, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT4, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType   = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT4, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT4, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;              //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;          //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;        //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;                 //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ

    res = SSPI_Init(SSPI31, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    //  ISR_Register(SPI31_IRQn, spi31_interrupt);       //жϷ·ע

    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    return SCI_SUCCESS;
}
#endif
/***********************************************************************************************************************
* Function Name: Spi_Int_Write
* @brief  spi write data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Int_Write(uint8_t *tx_buf, uint16_t tx_num)
{
    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Send);
    SSPI_Start(SSPI11);
    INTC_EnableIRQ(SPI11_IRQn);

    g_spi_tx_end = 0;
    g_spi_rx_end = 0;
    pData.data = tx_buf;    //send buffer pointer
    pData.len  = tx_num;  //set send data count
    pData.flag = SSPI_INT_TX;   //set data direction
    INTC_SetPendingIRQ(SPI11_IRQn);
}


/***********************************************************************************************************************
* Function Name: Spi_Int_Read
* @brief  spi read data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Int_Read(uint8_t *rx_buf, uint16_t rx_num)
{

    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Recv);
    SSPI_Start(SSPI11);
    INTC_EnableIRQ(SPI11_IRQn);
	g_spi_rx_end = 0;
    pData.data = rx_buf;   //read buffer pointer
    pData.len  = rx_num;   //set receive data count
    pData.flag = SSPI_INT_RX;   //set data direction

    SSPI_SendByte(SSPI11, 0xFF);
}

/***********************************************************************************************************************
* Function Name: Spi_Dma_Write
* @brief  spi write data by dma
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Dma_Write(uint8_t *tx_buf, uint16_t tx_num)
{

    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Send);   //ʹд־λ
    SSPI_Start(SSPI11);

    INTC_EnableIRQ(SPI11_IRQn);

    DMA_Sspi_Write(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal, tx_buf, (void *)&SSPI11_SDR, tx_num); //config dma transmission
    DMA_Trigger(DMA_VECTOR_SPI11);
    pData.flag = SSPI_INT_DMA;   //set data direction
#if 0   /*if you want to use interrput to trigger dma*/
    DMA_Sspi_Write(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal, tx_buf + 1, (void *)sci_reg.SIO, tx_num - 1); //config dma transmission

    *sci_reg.SIO = tx_buf[0];   //send finished will occur intterupt
    tx_buf++ ;

    pData.data = tx_buf;    //send buffer pointer
    pData.len  = 0;  //set send data count
    pData.flag = SSPI_INT_TX;   //set data direction
#endif
}

/***********************************************************************************************************************
* Function Name: DMA_Sspi_WriteRead
* @brief  SPI peripheral write data and recive data at the same time
* @param   tx_buf: tx_buf to be transmitted by the SPI peripheral
**         tx_num: num to be transmitted
**         rx_buf: received buffer by the SPI peripheral
**         rx_num: received num  by the SPI peripheral
* @return None
***********************************************************************************************************************/
void Spi11_Dma_TxRx(uint8_t *tx_buf, uint16_t tx_num, uint8_t *rx_buf, uint16_t rx_num)
{
	SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_TxRx);

	SSPI_Start(SSPI11);
	g_spi_tx_end = 0;
	g_spi_rx_end = 0;

	DMA_Sspi_WriteRead(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal,tx_buf+1, rx_buf, tx_num-1); //config dma transmission
	pData.flag = SSPI_INT_DMA;   //set data direction
	pData.data = &rx_buf[rx_num-1];
	SSPI_SendByte(SSPI11, tx_buf[0]); //interrupt triger the dma
}
/***********************************************************************************************************************
* Function Name: Spi_Dma_Read
* @brief  spi read data by dma
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Dma_Read(uint8_t *rx_buf, uint16_t rx_num)
{
    static uint8_t dummy_sio11 = 0xFFU;

    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Recv);

    SSPI_Start(SSPI11);
    g_spi_tx_end = 0;
    g_spi_rx_end = 0;	
#if 1
    DMA_Sspi_Read(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal, (void *)&SSPI11_SDR, rx_buf, rx_num - 1); //config dma transmission

    pData.flag = SSPI_INT_DMA;   //set data direction

    pData.data = rx_buf + rx_num - 1;
    SSPI_SendByte(SSPI11, dummy_sio11); //interrupt triger the dma
#else
    DMA_Sspi_Read(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal, (void *)sci_reg.SIO, rx_buf, rx_num); //config dma transmission
    pData.flag = SSPI_INT_DMA;
    *sci_reg.SIO = dummy_sio11;//interrupt triger the dma
#endif
}

/***********************************************************************************************************************
* Function Name: spi_callback_error
* @brief  UART0 Receive interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi_callback_error()
{
    //user edit here when appear error
}

/***********************************************************************************************************************
* Function Name: spi0_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi00_interrupt(void)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    SSPI_FRAME_t *pFrame = &pData;
    SCIAFSelect_TypeDef func = SSPI00;

    err_type = SSPI_GetErrStaus(SSPI00, SSPI_FLAG_OVERRUN);

    INTC_ClearPendingIRQ(SPI00_IRQn);


    if (1U == err_type)
    {
        spi_callback_error();//error condition
    }
    else
    {
        if (pFrame->flag == SSPI_INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    SSPI_SendByte(SSPI00, *pFrame->data);
                    pFrame->data++;
                    pFrame->len--;				
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if ((SSPI_Get_MasterMode(SSPI00) != SPI_Mode_Master) && (SSPI_Get_TransmitMode(SSPI00) != SSPI_TransmitMode_Recv))//slave mode :sclk is inputed by master clk
                    {
                        ;// when in slave mode ,do not need to wait end
                    }
                    else
                    {
                        while (SSPI_GetErrStaus(SSPI00, SCI_UNDER_EXECUTE)); //waitting conmunction end, if register ST turns 1,or SS turns 1
                    }
                }

                SSPI_Stop(func);
                g_spi_tx_end = 1;
            }
        }

        if (pFrame->flag == SSPI_INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI00);
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI00);
                }

                if (SSPI_Get_MasterMode(SSPI00) == SPI_Mode_Master)
                {
                    SSPI_SendByte(SSPI00, 0xFF);                   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while (SSPI_GetErrStaus(SSPI00, SCI_VALID_STORED) == 0); // wait last data stored in register SDR

                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI00);
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI00);
                }

                SSPI_Stop(func);
                g_spi_rx_end = 1;
            }
        }

        if (pFrame->flag == SSPI_INT_DMA)
        {
            SSPI_Stop(func);
            g_spi_tx_end = 1;
            g_spi_rx_end = 1;
        }
    }
}




/***********************************************************************************************************************
* Function Name: spi11_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi11_interrupt(void)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    SSPI_FRAME_t *pFrame = &pData;
    SCIAFSelect_TypeDef func = SSPI11;

    err_type = SSPI_GetErrStaus(SSPI11, SSPI_FLAG_OVERRUN);

    INTC_ClearPendingIRQ(SPI11_IRQn);

    if (1U == err_type)
    {
        spi_callback_error();//error condition
    }
    else
    {
        if (pFrame->flag == SSPI_INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    SSPI_SendByte(SSPI11, *pFrame->data);
                    pFrame->data++;
                    pFrame->len--;				
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if ((SSPI_Get_MasterMode(SSPI11) != SPI_Mode_Master) && (SSPI_Get_TransmitMode(SSPI11) != SSPI_TransmitMode_Recv))//slave mode :sclk is inputed by master clk
                    {
                        ;//slave mode;
                    }
                    else
                    {
                        while (SSPI_GetErrStaus(SSPI11, SCI_UNDER_EXECUTE)); //waitting conmunction end, if register ST turns 1,or SS turns 1
                    }
                }

                SSPI_Stop(func);
                g_spi_tx_end = 1;
            }
        }

        if (pFrame->flag == SSPI_INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI11);
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI11);
                }

                if (SSPI_Get_MasterMode(SSPI11) == SPI_Mode_Master)
                {
                    SSPI_SendByte(SSPI11, 0xFFU);  // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {
                while (SSPI_GetErrStaus(SSPI11, SCI_VALID_STORED) == 0); // wait last data stored in register SDR

                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI11);
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI11);
                }

                SSPI_Stop(func);
                g_spi_rx_end = 1;
            }
        }

        if (pFrame->flag == SSPI_INT_DMA)
        {
			while (SSPI_GetErrStaus(SSPI11, SCI_VALID_STORED) == 0); // wait last data stored in register SDR
			*pFrame->data = SSPI_ReceiveByte(SSPI11);
			
            SSPI_Stop(func);
            g_spi_tx_end = 1;
            g_spi_rx_end = 1;
        }
    }
}
