#ifndef __SPI_DEMO_H__
#define __SPI_DEMO_H__
#include "sspi.h"
#include "gpio.h"
#include "dma.h"
#include "isr.h"

typedef enum
{
	SSPI_INT_IDLE = 0,
	SSPI_INT_RX = 1,
	SSPI_INT_TX = 2,
	SSPI_INT_DMA =3,
}SSPI_DIR_t;

typedef struct 
{
	SSPI_DIR_t flag;
	uint32_t len;
	volatile uint8_t *data;
}SSPI_FRAME_t;
void spi00_interrupt(void);
void spi10_interrupt(void);
void spi11_interrupt(void);
void spi20_interrupt(void);
void spi21_interrupt(void);
int8_t Spi00_Slave_Init(void);
int8_t Spi10_Slave_Init(void);

void Spi00_Int_Write(uint8_t *tx_buf, uint16_t tx_num);
void Spi00_Int_Read(uint8_t *rx_buf, uint16_t rx_num);
void Spi00_Slave_Dma_Write(uint8_t *tx_buf, uint16_t tx_num);
void Spi00_Slave_Dma_Read(uint8_t *rx_buf, uint16_t rx_num);
#endif
