/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"
#include "cgc.h"
#include "pcbz.h"

#define TIME_ENABLE   1

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORT14, GPIO_Pin_0, GPIO_P140, GROUP_AF_CLKBUZ0); // CLKBUZ0 can be alternative to any desired pins with PxxCFG register

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT14, &GPIO_InitStruct);

	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_4;
	
	PCBZ_Init(&PCBZ_InitStructure);	
}
int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t width = 0, period;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);
	
    PCBZIO_Init();  //ͨʱP1402MHz 
#if 0
    /*Example4:Tim41 get external wave pluse widthpulse period*/
    Tim40_GetPulseWidth_Init();
	TIM_Start(TM40,TIM_Index_Channel0);
	
	while(1)
	{
		width = TIM_GetPulseWidth(TIM40,TIM_Index_Channel0);
		printf("P10/TI00 pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
		period = width * 2;
		printf("fCLK frequency = %dHz, error = %6.3f%%\n", period * 512, (((float)(period * 512) - SystemCoreClock) / SystemCoreClock * 100));
	}
#endif
	Tim40_GetPulsePeriod_Init();
	TIM_Start(TM40,TIM_Index_Channel0);
	
	while(1)
	{
		period = TIM_GetPulsePeriod(TM40,TIM_Index_Channel0);
		printf("P10/TI00 pulse width  = %d fCLK\n", period);  /* expected value: msCnt */
	}

}



