/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tima_demo.h"
#include "delay_demo.h"

//#define TMA_COUNT_UNDER_CTROL_CONDITION

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern  uint16_t g_tma0_underflow_count ;


int main()
{
	uint32_t msCnt,i; 	// count value of 1ms

//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	GPIO_InitTypeDef GPIO_InitStruct={};	

	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	delay_init(SystemCoreClock);
	
	Uart0_Init(19200);

#ifdef TMA_COUNT_UNDER_CTROL_CONDITION
	/*INTP4ΪߵƽP01ŵԴؽм,ֵﵽ5ж*/
	GPIO_InitStruct.GPIO_Pin	= GPIO_Pin_1;	
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
	GPIO_InitStruct.GPIO_Ctrl	= GPIO_Control_DIG;
	GPIO_Init(GPIO_PORT3,&GPIO_InitStruct);
	
	GPIO_InitStruct.GPIO_Pin	= GPIO_Pin_0;	
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
	GPIO_InitStruct.GPIO_Ctrl	= GPIO_Control_DIG;
	GPIO_Init(GPIO_PORT0,&GPIO_InitStruct);
	
	g_tma0_underflow_count = 0;

	TMA_EventCount_Init(TMA_RISING_EDGE,TMA_INTP4_HIGH_LEVEL,5);
	TMA_Start();


	GPIO_ResetBits(GPIO_PORT3,GPIO_Pin_1);	/* INTP4 = L */
	
	for(i=0; i<20; i++)
	{
		GPIO_ToggleBits(GPIO_PORT0,GPIO_Pin_0);
	}
	

	GPIO_SetBits(GPIO_PORT3,GPIO_Pin_1);	/* INTP4 = H */

	for(i=0; i<40; i++)
	{
		GPIO_ToggleBits(GPIO_PORT0,GPIO_Pin_0);
	}
	
	while(g_tma0_underflow_count == 0);
	printf("TMA event count while INTP4 high level is OK\n");
	
#else
	/*ͨP17ΣP01ţP01P17ؽм,ֵﵽ10жϣg_tma0_underflow_countֵ1*/	
	Gpio_Init();
	/*Example3:Tim4 count external event, when 10 pulses are captured, g_Int_Taken will increase 1*/
	TMA_EventCount_Init(TMA_RISING_EDGE,TMA_COUNT_AWLAYS, 10);
	TMA_Start();
	while(1)
	{
		GPIO_SetBits(GPIO_PORT1,GPIO_Pin_7);
		delayMS(250);
		GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_7);
		delayMS(250);
		printf("g_Int_Taken= %d\n", g_tma0_underflow_count);
	}	
#endif
}




