/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tima_demo.h"
#include "pcbz.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern volatile uint16_t g_tma0_ta0_value;   /* TA0 = 65535 */
extern volatile uint16_t g_tma0_underflow_count ;

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORT14, GPIO_Pin_0, GPIO_P140, GROUP_AF_CLKBUZ0); // CLKBUZ0 can be alternative to any desired pins with PxxCFG register

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT14, &GPIO_InitStruct);

	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_4;
	
	PCBZ_Init(&PCBZ_InitStructure);	
}

int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint32_t width;
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	
	Uart0_Init(19200);
    PCBZIO_Init();  //ͨʱP1402MHz 
#if 0
	/*ʵʱߵƽ*/
	TMA_Get_PulseWidth(TMA_FCLK_Div1, TMA_Pulse_Width_High);
    TMA_Start();	

	while(1)
	{
		width = TMA_GetPulseWidth();
		printf("P01/TAIO pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
	}
#endif
	/*ʵʱ*/
	TMA_Get_PulsePeriod(TMA_FCLK_Div1, TMA_Pulse_Rising);
	TMA_Start();

	while(1)
	{
		width = TMA_GetPulsePeriod();

		printf("P01/TAIO pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
	}
}

