/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "timb_demo.h"



/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint32_t width, period;
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 

//-----------------------------------------------------------------------
// No.33 pin(P50/TBIO0) output pulse
// No.34 pin(P51/TBIO1) output pulse
// period: 1000; skew: 300
//       period: |<---500--->| 
//       skew:   |<->|<--300				 
//	              _____       _____       _____
//	 TBIO0: _____|     |_____|     |_____|     |_____
//                    _____       _____       _____
//	 TBIO1: _________|     |_____|     |_____|     |_
//-----------------------------------------------------------------------
//	TMB_DoublePulseOutput(TMA_FCLK_Div1, 1000, 300);


//-----------------------------------------------------------------------
// No.33 pin(P50/TBIO0) output PWM wave
// period: 1000; duty: 300(30%)
//       period: |<---1000--->| 
//       duty:   |<->|<--300				 
//	              ___         ___         ___
//	 TBIO0: _____|   |_______|   |_______|   |_____
//-----------------------------------------------------------------------	
	TMB_PWM_1Period_1Duty(TMB_FCLK_Div1, 1000, 300);
	
}




