/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "timm_demo.h"
#include "pcbz.h"
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORT14, GPIO_Pin_0, GPIO_P140, GROUP_AF_CLKBUZ0); // CLKBUZ0 can be alternative to any desired pins with PxxCFG register

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT14, &GPIO_InitStruct);

	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_4;
	
	PCBZ_Init(&PCBZ_InitStructure);	
}

int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint32_t width, period;
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   

	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	
	Uart0_Init(19200);
    PCBZIO_Init();  //ͨʱP1402MHz 
	/*ʵʱ/*/
	TMM0_Get_PulseWidth_Init(TMM_FCLK_Div1, TMM_Capture_Rising);
	TMM0_Start(ENABLE);
	
	while(1)
	{
		width = TMM_GetPulseWidth(TMM0,TMM_Channel_A);

		printf("P17/TMIOA pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
	}
}




