/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A239
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "gpio_demo.h"
#include "wdt.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt, len;    // count value of 1ms
    uint32_t i;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);
    printf("Hello, UART\n");

    //-----------------------------------------------------------------------
    // Configure Option Byte C0H to enable WDT in system_BAT32G137.c
    //-----------------------------------------------------------------------
    for (i = 0; i < 8; i++)
    {
        __HALT();   /* Sleep */
        printf("\rWake up from sleep by WDT interrupt: No.%02d\n", g_WdtIntTaken);
    }

    for (i = 0; i < 8; i++)
    {
        __STOP();   /* Deep Sleep */
        printf("\rWake up from deep sleep by WDT interrupt: No.%02d\n", g_WdtIntTaken);
    }
}




